Subject: [Ltru] [Technical Errata Reported] RFC5646 (5457)

From: RFC Errata System <[email-masked]>
Date: Sun, 12 Aug 2018 12:28:17 -0700 (PDT)

The following errata report has been submitted for RFC5646,
"Tags for Identifying Languages".

--------------------------------------
You may review the report below and at:
http://www.rfc-editor.org/errata/eid5457

--------------------------------------
Type: Technical
Reported by: Peter Occil <[email-masked]>

Section: 2.2.9

Original Text
-------------
   A tag is considered "valid" if it satisfies these conditions:

   o  The tag is well-formed.

   o  Either the tag is in the list of grandfathered tags or all of its
      primary language, extended language, script, region, and variant
      subtags appear in the IANA Language Subtag Registry as of the
      particular registry date.

   o  There are no duplicate variant subtags.

   o  There are no duplicate singleton (extension) subtags.

Corrected Text
--------------
   A tag is considered "valid" if it satisfies these conditions:

   o  The tag is well-formed.

   o  Either the tag is in the list of grandfathered tags or all of its
      primary language, extended language, script, region, and variant
      subtags appear in the IANA Language Subtag Registry as of the
      particular registry date.

   o  There are no duplicate variant subtags.

   o  There are no duplicate singleton (extension) subtags.

   o  There is no more than one extended language subtag.

Notes
-----
Sec. 2.2.2 contains an additional validity requirement (point 4): the existence of no more than one extended language subtag.  This is not reflected in the definition of validity given in sec. 2.2.9 of the RFC.

Instructions:
-------------
This erratum is currently posted as "Reported". If necessary, please
use "Reply All" to discuss whether it should be verified or
rejected. When a decision is reached, the verifying party  
can log in to change the status and edit the report, if necessary. 

--------------------------------------
RFC5646 (draft-ietf-ltru-4646bis-23)
--------------------------------------
Title               : Tags for Identifying Languages
Publication Date    : September 2009
Author(s)           : A. Phillips, Ed., M. Davis, Ed.
Category            : BEST CURRENT PRACTICE
Source              : Language Tag Registry Update
Area                : Applications
Stream              : IETF
Verifying Party     : IESG

---

From: John Cowan <[email-masked]>
Date: Sun, 12 Aug 2018 15:33:08 -0500

On Sun, Aug 12, 2018 at 2:28 PM, RFC Errata System <
[email-masked]> wrote:

> Sec. 2.2.2 contains an additional validity requirement (point 4): the
> existence of no more than one extended language subtag.  This is not
> reflected in the definition of validity given in sec. 2.2.9 of the RFC.
>

It seems to me that it's 2.2.2  rather than 2.2.9 that's at fault.  2.2.2
says:

       That is, the second and third extended language
       subtag positions in a language tag are permanently reserved and
       tags that include those subtags in that position are, and will
       always remain, invalid.

However, the grandfathered tag "zh-min-nan" is valid by the definition in
2.2.9 even though it has a second extended language subtag. So since the
above sentence is not normative (it merely explains what is believed to be
a consequence of the preceding statements), it should be removed.

In the alternative, we can simply not worry about it:

The Tract produced an immense sensation, for it seemed to be a deadly and
> treacherous blow aimed at the very heart of the Church of England. Deadly
> it certainly was, but it was not so treacherous as at first sight appeared.
> The members of the English Church had ingenuously imagined up to that
> moment that it was possible to contain in a frame of words the subtle
> essence of their complicated doctrinal system, involving the mysteries of
> the Eternal and the Infinite on the one hand, and the elaborate adjustments
> of temporal government on the other. They did not understand that verbal
> definitions in such a case will only perform their functions so long as
> there is no dispute about the matters which they are intended to define :
> that is to say, so long as there is no need for them. For generations this
> had been the case with the Thirty-nine Articles. *Their drift was clear
> enough ; and no body bothered over their exact meaning.* But directly
> some one found it important to give them a new and untraditional
> interpretation, it appeared that they were a mass of ambiguity, and might
> be twisted into meaning very nearly anything that anybody liked.
> Steady-going churchmen were appalled and outraged when they saw Newman, in
> Tract No. 90, performing this operation. But, after all, he was only taking
> the Church of England at its v/ord. And indeed, since Newman showed the
> way, the operation has become so exceedingly common that the most
> steady-going church- man hardly raises an eyebrow at it now.

--Lytton Strachey,* Eminent Victorians* (emphasis added)

---

From: "Phillips, Addison" <[email-masked]>
Date: Sun, 12 Aug 2018 23:03:05 +0000

Hi John and Peter,

“zh-min-nan” is grandfathered and thus valid because it is in that list. It doesn’t have two extlangs, even though it looks like it does. Grandfathered tags are exempt from the other rules.

I think the Peter has a point. The “well-formed” rules mirror the ABNF and the “valid” rules were meant to mirror the ABNF plus the registry. There was some effort expended to make the validity rules “forward compatible” with future potential changes to BCP47. Hence in 4646 days they allowed for future use of extlangs (when point 4 said you must not use extlangs now but that they were reserved). When extlangs came in during 5646 we ruled out the second and third extlang in point 4 but not in the ABNF. Since we say the second and third extlang can never ever be valid, the validity rules should reflect that.

Addison

Addison Phillips
Principal SDE, I18N Architect (Amazon)
Chair (W3C I18N WG)

Internationalization is not a feature.
It is an architecture.

From: Ltru [mailto:[email-masked]] On Behalf Of John Cowan
Sent: Monday, August 13, 2018 4:33 AM
To: RFC Errata System <[email-masked]>
Cc: [email-masked]; [email-masked]; [email-masked]; [email-masked]; Alexey Melnikov <[email-masked]>; [email-masked]; [email-masked]; [email-masked]
Subject: Re: [Ltru] [Technical Errata Reported] RFC5646 (5457)

On Sun, Aug 12, 2018 at 2:28 PM, RFC Errata System <[email-masked]<mailto:[email-masked]>> wrote:

It seems to me that it's 2.2.2  rather than 2.2.9 that's at fault.  2.2.2 says:

       always remain, invalid.

However, the grandfathered tag "zh-min-nan" is valid by the definition in 2.2.9 even though it has a second extended language subtag.. So since the above sentence is not normative (it merely explains what is believed to be a consequence of the preceding statements), it should be removed.

The Tract produced an immense sensation, for it seemed to be a deadly and treacherous blow aimed at the very heart of the Church of England. Deadly it certainly was, but it was not so treacherous as at first sight appeared. The members of the English Church had ingenuously imagined up to that moment that it was possible to contain in a frame of words the subtle essence of their complicated doctrinal system, involving the mysteries of the Eternal and the Infinite on the one hand, and the elaborate adjustments of temporal government on the other. They did not understand that verbal definitions in such a case will only perform their functions so long as there is no dispute about the matters which they are intended to define : that is to say, so long as there is no need for them. For generations this had been the case with the Thirty-nine Articles. Their drift was clear enough ; and no body bothered over their exact meaning. But directly some one found it important to give them a new and untraditional interpretation, it appeared that they were a mass of ambiguity, and might be twisted into meaning very nearly anything that anybody liked. Steady-going churchmen were appalled and outraged when they saw Newman, in Tract No. 90, performing this operation. But, after all, he was only taking the Church of England at its v/ord. And indeed, since Newman showed the way, the operation has become so exceedingly common that the most steady-going church- man hardly raises an eyebrow at it now.

--Lytton Strachey, Eminent Victorians (emphasis added)